/**
 * id: insertunit
 * author: WangZhicheng <245565986@qq.com>
 * version: 0.2
 * update: 2012/3/15 15:28
 * usage: $('textarea').insertunit(':)'); or $('textarea').insertunit('<b>', '</b>');
 */
;
(function($) {
	$.fn.extend({
		insertunit: function(text, textend) {
			var holder = text;
			textend = (typeof textend == 'undefined') ? '': textend;
			return this.each(function(i) {
				if (document.selection) {
					this.focus();
					selection = document.selection.createRange();
					if (textend != '') {
						text = text + selection.text + textend;
					}
					selection.text = text;
					this.focus();
				} else if (this.selectionStart || this.selectionStart == '0') {
					var startPos = this.selectionStart;
					var endPos = this.selectionEnd;
					var scrollTop = this.scrollTop;
					if (textend != '') {
						text = text + this.value.substring(startPos, endPos) + textend;
					}
					this.value = this.value.substring(0, startPos) + text + this.value.substring(endPos, this.value.length);
					this.focus();
					this.selectionStart = startPos + text.length;
					this.selectionEnd = startPos + text.length;
					this.scrollTop = scrollTop;
				} else {
					if (textend != '') {
						text = text + this.value + textend;
					} else {
						text = this.value + text;
					}
					this.value = text;
					this.focus();
				}
				text = holder;
			});
		}
	});
})(jQuery);